'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var Constants = exports.Constants = {
  REGISTER: '@@navigation:anchor:register',
  UNREGISTER: '@@navigation:anchor:unregister',
  UPDATE: '@@navigation:anchor:update'
};

var updateAnchors = function updateAnchors(action) {
  return function (parentId, props, configuration) {
    return {
      type: Constants[action],
      payload: { parentId: parentId, props: props, configuration: configuration }
    };
  };
};

var registerAnchor = exports.registerAnchor = updateAnchors('REGISTER');
var unregisterAnchor = exports.unregisterAnchor = updateAnchors('UNREGISTER');
var updateAnchorWithNewProps = exports.updateAnchorWithNewProps = updateAnchors('UPDATE');