'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Anchor = function (_PureComponent) {
  _inherits(Anchor, _PureComponent);

  function Anchor() {
    _classCallCheck(this, Anchor);

    var _this = _possibleConstructorReturn(this, (Anchor.__proto__ || Object.getPrototypeOf(Anchor)).call(this));

    _this.setRef = _this.setRef.bind(_this);
    return _this;
  }

  _createClass(Anchor, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          offsetTop = _props.offsetTop,
          offsetBottom = _props.offsetBottom;


      this.props.registerAnchor(this.getParentElementId(), this.props.ownProps, { offsetTop: offsetTop, offsetBottom: offsetBottom });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.props.unregisterAnchor(this.getParentElementId());
    }
  }, {
    key: 'getParentElementId',
    value: function getParentElementId() {
      return this.ref.parentElement.id;
    }
  }, {
    key: 'setRef',
    value: function setRef(ref) {
      this.ref = ref;
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement('div', { ref: this.setRef });
    }
  }]);

  return Anchor;
}(_react.PureComponent);

Anchor.displayName = 'Anchor';
Anchor.propTypes = {
  registerAnchor: _propTypes2.default.func.isRequired,
  unregisterAnchor: _propTypes2.default.func.isRequired,
  offsetTop: _propTypes2.default.number,
  offsetBottom: _propTypes2.default.number,
  disabled: _propTypes2.default.bool,
  ownProps: _propTypes2.default.shape({})
};
Anchor.defaultProps = {
  offsetTop: 0,
  offsetBottom: 0
};
exports.default = Anchor;