'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createReducer;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _actions = require('../actions/actions');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var createReducer = function createReducer(initialState, handlers) {
  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];

    if (handlers.hasOwnProperty(action.type)) {
      return handlers[action.type](state, action);
    }

    return state;
  };
};

var sort = function sort(anchors) {
  var scrollY = window.scrollY || window.pageYOffset;

  /* eslint-disable no-param-reassign */
  var offsets = anchors.reduce(function (out, a) {
    var el = document.getElementById(a.parentId);

    if (el) {
      out[a.parentId] = el.getBoundingClientRect().top + scrollY;
    }
    return out;
  }, {});
  /* eslint-enable no-param-reassign */

  return anchors.sort(function (a, b) {
    return offsets[a.parentId] - offsets[b.parentId];
  });
};

var getInitialState = function getInitialState() {
  return {
    anchors: []
  };
};

var reducer = createReducer(getInitialState(), (_createReducer = {}, _defineProperty(_createReducer, _actions.Constants.REGISTER, function (state, action) {
  var _action$payload = action.payload,
      parentId = _action$payload.parentId,
      props = _action$payload.props,
      configuration = _action$payload.configuration,
      anchors = sort([].concat(_toConsumableArray(state.anchors), [{ parentId: parentId, props: props, configuration: configuration }]));


  return _extends({}, state, { anchors: anchors });
}), _defineProperty(_createReducer, _actions.Constants.UNREGISTER, function (state, action) {
  var anchors = state.anchors.filter(function (a) {
    return a.parentId !== action.payload.parentId;
  });
  return _extends({}, state, { anchors: anchors });
}), _defineProperty(_createReducer, _actions.Constants.UPDATE, function (state, action) {
  var _action$payload2 = action.payload,
      parentId = _action$payload2.parentId,
      props = _action$payload2.props,
      configuration = _action$payload2.configuration,
      index = state.anchors.findIndex(function (a) {
    return a.parentId === parentId;
  });


  if (index !== -1) {
    var anchors = [].concat(_toConsumableArray(state.anchors));
    anchors[index] = { parentId: parentId, props: props, configuration: configuration };
    return _extends({}, state, { anchors: sort(anchors) });
  }

  return state;
}), _createReducer));

exports.default = reducer;